<?php

function conf_read ($fn) {

	$fp = @fopen($fn, "r");
	if ($fp) {
		$fcont = fread($fp, filesize($fn));
		fclose($fp);

		$conf_arr = explode("\n", $fcont);

		$ret_arr = array();

		foreach ($conf_arr as $line) {
			if (!empty($line)) {
				$tmp_arr = explode("=", $line);
				$ret_arr[$tmp_arr[0]] = $tmp_arr[1];
			}
		}
	}

	return($ret_arr);
}

function conf_write ($fn, $conf) {

	$fields = array(
		"pop3_host", "pop3_port", "pop3_user", "pop3_pass", "pop3_purge",
		"smtp_host", "smtp_port", "smtp_user", "smtp_pass", "smtp_from", "smtp_rcpt",
		"mail_edge", "smgw_ssl");

	foreach ($fields as $field) {
		if (($field == "mail_edge") && (empty($conf[$field]))) {
			$fcont .= $field ."=SMSEND\n";
		} else {
			$fcont .= $field . "=" . $conf[$field] . "\n";
		}
	}

	$fp = fopen($fn, "w");
	fwrite($fp, $fcont);
	fclose($fp);
}

function conf_print ($conf) {

	$div = "<div style=\"float: left; width: 100px;\">";

	$ret	= "<form action=\"index.php\" name=\"smgw\" method=\"POST\" onsubmit=\"return validateConf()\">\n" .
		  "<h3>POP3 Configuration:</h3>\n" .
		  "<div style=\"float: right; width: 150px;\"><input type=\"submit\" name=\"test\" value=\"Test Settings\" /></div>\n" .
		  $div . "Hostname:</div><input type=\"text\" name=\"pop3_host\" value=\"" . $conf[pop3_host] . "\" /><br />\n" .
		  $div . "Port:</div><input type=\"text\" name=\"pop3_port\" value=\"" . $conf[pop3_port] . "\" /><br />\n" .
		  $div . "Username:</div><input type=\"text\" name=\"pop3_user\" value=\"" . $conf[pop3_user] . "\" /><br />\n" .
		  $div . "Password:</div><input type=\"password\" name=\"pop3_pass\" value=\"" . $conf[pop3_pass] . "\" /><br />\n" .
		  "<h3>SMTP Configuration:</h3>\n" .
		  $div . "Hostname:</div><input type=\"text\" name=\"smtp_host\" value=\"" . $conf[smtp_host] . "\" /><br />\n" .
		  $div . "Port:</div><input type=\"text\" name=\"smtp_port\" value=\"" . $conf[smtp_port] . "\" /><br />\n" .
		  $div . "Username:</div><input type=\"text\" name=\"smtp_user\" value=\"" . $conf[smtp_user] . "\" /><br />\n" .
		  $div . "Password:</div><input type=\"password\" name=\"smtp_pass\" value=\"" . $conf[smtp_pass] . "\" /><br />\n" .
		  $div . "From:</div><input type=\"text\" name=\"smtp_from\" value=\"" . $conf[smtp_from] . "\" /><br />\n" .
		  $div . "Recipient:</div><input type=\"text\" name=\"smtp_rcpt\" value=\"" . $conf[smtp_rcpt] . "\" /><br />\n" .
		  "<h3>Generic Configuration:</h3>\n" .
		  $div . "use SSL:</div><input type=\"checkbox\" name=\"smgw_ssl\" value=\"1\" " .
		  ($conf[smgw_ssl] ? "checked " : "") . " />\n" .
		  "<div style=\"float: right; width: 150px;\"><input type=\"submit\" name=\"save\" value=\"Save Settings\" /></div>\n" .
		  "</form>\n";

	return($ret);

}

function log_print ($fn) {

	$ret = "<div style=\"font-family: monospace; height: 300px; width: 700px; overflow: scroll; white-space: nowrap;\">\n";

	if (!file_exists($fn)) {
		$ret .= "File empty.<br />\n";
		$ret .= "</div>\n";

		return($ret);
	}

	$data = array_slice(file($fn), -64);

	foreach ($data as $line) {
		$ret .= $line . "<br />\n";
	}

	$ret .= "</div>\n";

	return($ret);
}

function conf_test ($conf) {

	$cmd =  "../bin/mail_test" .
		" --ph " . $conf[pop3_host] . " --pp " . $conf[pop3_port] . " --pu " . $conf[pop3_user] . " --px " . $conf[pop3_pass] .
		" --sh " . $conf[smtp_host] . " --sp " . $conf[smtp_port] . " --su " . $conf[smtp_user] . " --sx " . $conf[smtp_pass] .
		($conf[smgw_ssl] == 1 ? " --ssl" : "");

	putenv("LD_LIBRARY_PATH=../lib");
	exec($cmd, $test_res);

	return($test_res);
}

function test_print ($test_res) {

	if (empty($test_res)) {
		return("");
	}

	$color_pop3 = ($test_res[0] == "OK" ? "green" : "red");
	$color_smtp = ($test_res[1] == "OK" ? "green" : "red");

	$ret =	"<h2>Results of Configuration-Test</h2>\n" .
		"POP3: <div style=\"float: right; width: 75px; color: " . $color_pop3 . ";\">" . $test_res[0] . "</div><br />\n" .
		"SMTP: <div style=\"float: right; width: 75px; color: " . $color_smtp . ";\">" . $test_res[1] . "</div>\n";

	return($ret);
}

function validateConf_print () {

	$ret =	"\t<script type=\"text/javascript\">\n" .
		"\tfunction validateConf() {\n" .
		"\t\tvar pop3_host=document.forms[\"smgw\"][\"pop3_host\"].value;\n" .
		"\t\tvar pop3_port=document.forms[\"smgw\"][\"pop3_port\"].value;\n" .
		"\t\tvar pop3_user=document.forms[\"smgw\"][\"pop3_user\"].value;\n" .
		"\t\tvar pop3_pass=document.forms[\"smgw\"][\"pop3_pass\"].value;\n\n" .
		"\t\tif (pop3_host != null && pop3_host != \"\") {\n" .
		"\t\t\tif (pop3_port == null || pop3_port == \"\" || pop3_user == null || pop3_user == \"\" || pop3_pass == null || pop3_pass ==\"\") {\n" .
		"\t\t\t\talert(\"Configuration for POP3 Server is incomplete!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n" .
		"\t\t\tif (pop3_port <= 0 || pop3_port >= 65536) {\n" .
		"\t\t\t\talert(\"POP3 port needs to be between 1 and 65535!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n" .
		"\t\t}\n\n" .
		"\t\tvar smtp_host=document.forms[\"smgw\"][\"smtp_host\"].value;\n" .
		"\t\tvar smtp_port=document.forms[\"smgw\"][\"smtp_port\"].value;\n" .
		"\t\tvar smtp_user=document.forms[\"smgw\"][\"smtp_user\"].value;\n" .
		"\t\tvar smtp_pass=document.forms[\"smgw\"][\"smtp_pass\"].value;\n" .
		"\t\tvar smtp_from=document.forms[\"smgw\"][\"smtp_from\"].value;\n" .
		"\t\tvar smtp_rcpt=document.forms[\"smgw\"][\"smtp_rcpt\"].value;\n\n" .
		"\t\tif (smtp_host != null && smtp_host != \"\") {\n" .
		"\t\t\tif (smtp_port == null || smtp_port == \"\" || smtp_user == null || smtp_user == \"\" || smtp_pass == null || smtp_pass ==\"\") {\n" .
		"\t\t\t\talert(\"Configuration for SMTP Server is incomplete!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n" .
		"\t\t\tif (smtp_from == null || smtp_from == \"\" || smtp_rcpt == null || smtp_rcpt == \"\") {\n" .
		"\t\t\t\talert(\"Sender or Recipient mail-address are empty!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n" .
		"\t\t\tif (smtp_port <= 0 || smtp_port >= 65536) {\n" .
		"\t\t\t\talert(\"SMTP port needs to be between 1 and 65535!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n\n" .
		"\t\t\tvar atpos=smtp_from.indexOf(\"@\");\n" .
		"\t\t\tvar dotpos=smtp_from.indexOf(\".\");\n\n" .
		"\t\t\tif (atpos < 1 || dotpos < (atpos + 2) || (dotpos + 2) >= smtp_from.length) {\n" .
		"\t\t\t\talert(\"Sender mail-address is not valid!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n\n" .
		"\t\t\tvar atpos=smtp_rcpt.indexOf(\"@\");\n" .
		"\t\t\tvar dotpos=smtp_rcpt.indexOf(\".\");\n\n" .
		"\t\t\tif (atpos < 1 || dotpos < (atpos + 2) || (dotpos + 2) >= smtp_rcpt.length) {\n" .
		"\t\t\t\talert(\"Recipient mail-address is not valid!\");\n" .
		"\t\t\t\treturn false;\n" .
		"\t\t\t}\n" .
		"\t\t}\n" .
		"\treturn true;\n" .
		"\t}\n" .
		"\t</script>\n";

	return($ret);
}

@session_start();
if (!isset($_SESSION['beroari_time'])) {
	header("Location:/app/berogui/includes/login.php");
} elseif ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time'] + 1200) < time())) {
	@session_unset();
	@session_destroy();
	header("Location:/app/berogui/includes/login.php");
}

$_SESSION['beroari_time'] = time();

if (!(empty($_POST["save"]))) {
	conf_write("../etc/smgw.conf", $_POST);
}

if (!empty($_POST["test"])) {
	$conf = $_POST;
	$test_res = conf_test($conf);
} else {
	$conf = conf_read("../etc/smgw.conf");
}

echo	"<xml version=\"1.0\" encoding=\"UTF-8\">\n" .
	"\t<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n" .
	"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n" .
	"\t<head>\n" .
	"\t\t<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n" .
	"\t\t<link type=\"text/css\" href=\"/userapp/css/beroApp.css\" rel=\"Stylesheet\" />\n" .
	"\t\t<link rel=\"icon\" href=\"/app/berogui/includes/images/favicon.ico\" type=\"image/x-icon\" />\n" .
	"\t\t<title>SMGW</title>\n" .
	validateConf_print() .
	"\t</head>\n" .
	"\t<body>\n" .
	"\t\t<div class=\"main\">\n" .
	"\t\t\t<div class=\"top\"><img src=\"/app/berogui/includes/images/bg_top.png\" /></div>\n" .
	"\t\t\t<div class=\"left\">\n" .
	"\t\t\t\t<div>Menu: <a href=\"/app/berogui/\">berogui</a> | <a href=\"/userapp/\">UserApp Management</a> | <a href=\"\">reload</a></div>\n" .
	"\t\t\t\t<h1>SMGW</h1>\n" .
	"\t\t\t\t<h2>Configuration</h2>\n" .
	conf_print($conf) .
	test_print($test_res) .
	"\t\t\t\t<h2>Logfile</h2>\n" .
	log_print("/var/log/smgw.log") .
	"\t\t\t\t<h2>Error Logfile</h2>\n" .
	log_print("/var/log/smgw.err") .
	"\t\t\t</div>\n" .
	"\t\t\t<div class=\"bottom\"><img src=\"/app/berogui/includes/images/bg_bottom.png\" /></div>\n" .
	"\t\t</div>\n" .
	"\t</body>\n" .
	"</html>";

?>
